(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* SCAP                                                        *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: scap_2.v,v 1.1.1.1 2006/12/07 16:43:23 ssg05 Exp $ *)

Require Import bnat.
Require Import scap.
Require Import extac.

Ltac psi_lookup label :=
  match goal with
    | H : CHSpec.lookup ?psi ?f (mk_cdspec ?p ?g)
      |- _ =>
        decbeqnat f label;
        [ substH H with (@CHSpec.lookup_get psi f _ H);
          unfold CHSpec.get, CHSpecDef.get in H;
          unfold psi in H;
          simplbnat;
          substbnat f;
          simpl in H;
          (match type of H with 
             | NoneT = SomeT _  => discriminate H
             | SomeT (mk_cdspec ?p' ?g') = SomeT (mk_cdspec p g) => 
               inversion H; subst
           end)
          |idtac ]
    | _ => idtac
  end.

Ltac psi_lookup_not :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a |- _ =>
      substH H with (@CHSpec.lookup_get psi f a H);
      unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;      
      unfold psi, CHSpecDef.beq in H; simplbnat; simpl in H;
        (match type of H with
           | NoneT = SomeT _ => discriminate H
           | _ => fail
         end)
    | _ => fail
  end.
