(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Tiny Machine                                                *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: Word.v,v 1.1.1.1 2006/12/07 16:43:22 ssg05 Exp $ *)

Require Export natpm.
Require Export bnat.

Notation word := nat.

Notation label := nat.

Definition B := word.

Implicit Types w : word.

Theorem nat_eq_dec : forall a b : nat, {a = b} + {a <> b}.
Proof.
  intros.
  compare a b.
  auto.
  auto.
Qed.
