(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Typed Assembly Language                                     *)
(*                                                             *)
(* TAL Prime                                                   *)
(***************************************************************)

(* $Id: Talp.v,v 1.1.1.1 2006/12/07 16:43:21 ssg05 Exp $ *)

Require Export Ty.
Require Export TyEnv.
Require Export Varmap.

Require Export Subst.
Require Export Subst_lemmas.
Require Export Unify.
Require Export Unify_lemmas.

Require Export Rule.
Require Export Tyok_lemmas.
Require Export SubTy_lemmas.
Require Export Rule_lemmas.

Require Export TyCk.
Require Export Soundness.

Require Export extac.
